<?php
require_once(realpath(dirname(__FILE__)). '/LC_Page_Mdl_Dchk.php');

class LC_Page_Mdl_Dchk_Credit extends LC_Page_Mdl_Dchk {

    /**
     * @see LC_Page_Mdl_Dchk::action()
     */
    function action(){

        $objSiteSess = new SC_SiteSession();
        $objCustomer = new SC_Customer();
        $objParam    = new SC_FormParam();
        $objQuery = new SC_Query();
        
        $order_id = $_SESSION['order_id'];
        $this->transactionid = $this->getToken();
        
        $arrOrderData = $this->getOrder($order_id,$objQuery);
        $this->idpayment = false;
        $this->shop_id = $this->credit_shop_id;
        
        if(SC_MobileUserAgent::isMobile()){
            $mobile = true;
            $objView = new SC_MobileView();
        }else{
            $mobile = false;
            $objView = new SC_SiteView();
        }
        
        if ($arrOrderData['payment_total'] == 0) {
            $this->skipSettlement($order_id,$mobile);
        }

        //ID決済
        if (($_SESSION['use_regcard'] == 1) 
            and $arrOrderData["customer_id"] > 0 
            and $objCustomer->getValue("regist_card") == 1) {
            LC_Helper_Mdl_Dchk::log("クレジットID決済を行います:".$_SESSION['use_regcard']);
            // ID決済の場合
            $this->idpayment = true;

            // POSTデータを送信し、応答情報を取得する
            // データ作成
            $arrSendData = $this->createSendData($order_id);
            $response = LC_Helper_Mdl_Dchk::POST(DCHK_CREDIT_URL, $arrSendData);

            // なにも返ってこなれば、エラー
            if ($response == "") {
                // エラー画面を表示する。
                $_SESSION['site']['now_page'] ="";
                $this->rollbackOrder($order_id);
                LC_Helper_Mdl_Dchk::log("URL:$order_url 応答がありません。");
                $this->arrEr = array("応答がありません");
                $this->viewError($objView);
            }
            $arrResponse = explode("\r\n", mb_convert_encoding($response,"UTF-8", "SJIS"));
            if ($arrResponse[0] != "OK") {
                $this->rollbackOrder($order_id);
                LC_Helper_Mdl_Dchk::log(print_r($response,1));
                if (mbereg(".*EXPERR.*", $response)) {
                    $this->arrEr = array("message"=>"有効期限切れエラーです");
                    LC_Helper_Mdl_Dchk::log("有効期限切れエラーです");
                } else if (mbereg(".*PRERROR.*", $response))  {
                    $this->arrEr = array("message"=>"パラメータエラーです。[メッセージ：".$arrResponse[2]."]");
                    LC_Helper_Mdl_Dchk::log("パラメータエラーです。[メッセージ：".print_r($arrResponse,1)."]");
                } else {
                    $this->arrEr = array("message"=>"システムエラーです。[メッセージ：".$arrResponse[2]."]");
                    LC_Helper_Mdl_Dchk::log("システムエラーです。[メッセージ：".print_r($arrResponse,1)."]");
                }
                $objSiteSess->setRegistFlag();
                $this->viewError($objView);
            } else {
                LC_Helper_Mdl_Dchk::log('ID決済完了。完了ページに移動します');
                $objSiteSess->setRegistFlag();
                if ($this->credit_kakutei == "true"){ //確定処理は管理画面の設定に従う
                    $this->completeSettlement($order_id,$arrResponse);
                }
                $this->sendRedirect($this->getLocation(URL_SHOP_COMPLETE),$mobile);
            }
        //通常決済
        } else {
            $objSiteSess = new SC_SiteSession();
            // EC-CUBE確認画面からの遷移
            $order_id = $_SESSION['order_id'];
            LC_Helper_Mdl_Dchk::log('受注ID:'.$order_id);
    
            if($_GET["return"] == 1){
                $this->rollbackOrder($order_id);
                $objSiteSess->setRegistFlag();
                $this->sendRedirect($this->getLocation(URL_SHOP_PAYMENT),$mobile);
                exit;
            }
    
    
            if ($_SERVER['REQUEST_METHOD'] === 'GET') {
                // 戻りパラメータがある時
                if ($this->checkRetParam($_GET)) {
                    LC_Helper_Mdl_Dchk::log('DCHKからの戻り値:'.print_r($_GET, true));
                    // 正常完了処理
                    $objSiteSess->setRegistFlag();
                    
                    if ($this->credit_kakutei == "true"){ //確定処理は管理画面の設定に従う
                        $this->completeSettlement($order_id);
                    }
                    //ID決済用フラグ設定
                    if($arrOrderData["customer_id"] > 0){
                        $this->setRegistCard($arrOrderData["customer_id"]);
                    }

                    LC_Helper_Mdl_Dchk::log('完了ページに移動します');
                    $this->sendRedirect($this->getLocation(URL_SHOP_COMPLETE),$mobile);
    
                } else if ($_GET['transactionid']) {
                    LC_Helper_Mdl_Dchk::log("オーダーURL：".$this->getOrderUrl()."へリダイレクトします");
                    // データ作成
                    $arrSendData = $this->createSendData($order_id);
                    LC_Helper_Mdl_Dchk::log("パラメータ：".mb_convert_encoding(print_r($arrSendData, 1),"UTF-8","SJIS"));
                    // 送信先URLへリダイレクト
                    LC_Helper_Mdl_Dchk::sendRedirect($this->getOrderUrl(),$arrSendData);
                } else {
                    LC_Helper_Mdl_Dchk::log('パラメータが不正です:'.print_r($_GET,true));
                    $this->rollbackOrder($order_id);
                    $this->sendRedirect($this->getLocation(URL_SHOP_CONFIRM),$mobile);
                }
            } else {
                // POSTの場合
                LC_Helper_Mdl_Dchk::log('不正な'.$_SERVER['REQUEST_METHOD'].'リクエストを受信しました');
                $this->rollbackOrder($order_id);
                $this->sendRedirect($this->getLocation(URL_SHOP_CONFIRM),$mobile);
            }
        }
    }

    function viewError(&$objView) {
        $this->tpl_mainpage = LC_Helper_Mdl_Dchk::getTemplateDir('credit_error.tpl');
        $objView->assignobj($this);
        $objView->display(SITE_FRAME);
    }

    /**
     * 発注データを取得します.
     */
    function getOrderData($order_id) {

        if ($_SESSION['use_regcard'] == 1) {
            $arrSendData = array(
                'PASS' => $this->credit_shop_pass
            );
        } else {
            return parent::getOrderData($order_id);
        }
        return $arrSendData;
    }

    /**
     * 決済方法を取得します。
     */
    function getStore() {
      return "51";
    }

    /**
     * 完了URLを取得します。
     */
    function getOkUrl() {
        $url = SSL_URL.'shopping/load_payment_module.php?'.TRANSACTION_ID_NAME."=".$this->transactionid;
        if(SC_MobileUserAgent::isMobile()){
            $url .= "&". session_name() ."=". session_id() ;
        }
        return $url;
    }

    /**
     * 戻りURLを取得します。
     */
    function getReturnUrl() {
        $url = SSL_URL.'shopping/load_payment_module.php?return=1&'.TRANSACTION_ID_NAME."=".$this->transactionid;
        if(SC_MobileUserAgent::isMobile()){
            $url .= "&". session_name() ."=". session_id() ;
        }
        return $url;
    }

        /**
     * 決済ごとの独自情報を取得します。
     */
    function getExtData() {
        if($_SESSION['customer']['customer_id'] > 0){
            return array(
                'KAKUTEI' => 0, // 与信
                'IP_USER_ID' => $_SESSION['customer']['customer_id'] // ユーザID
            );
        }else{
            return array(
                'KAKUTEI' => 0 // 与信
            );
        }
    }

    /**
     * 送信先URLを取得します。
     * @see LC_Page_Mdl_Dchk::getOrderUrl()
     */
    function getOrderUrl() {
        return DCHK_CREDIT_LINK;
    }
    
    /**
     * 戻りURLを取得します。
     */
    function setRegistCard($customer_id){
        LC_Helper_Mdl_Dchk::log("ID決済用フラグ設定 customer_id: ".$customer_id);
        $objQuery = new SC_Query();
        $sqlval = array("regist_card" => 1);
        $objQuery->update("dtb_customer",$sqlval,"customer_id = ?",array($customer_id));
    }
    
    //通常完了時のステータス設定
    function completeSettlement($order_id) {
        $objQuery = new SC_Query();
        $sqlval = array(
            'update_date' => 'now()',
            'dchk_status' =>DCHK_STATUS_COMPLETE,
            'status'=> ORDER_NEW
        );
        $commit = array(
            "IP"=>$this->shop_id,
            "SID"=>$order_id
        );
        $response = LC_Helper_Mdl_Dchk::POST(DCHK_CREDIT_COMPLETE_URL, $commit);
        $arrResponse = explode("\r\n", mb_convert_encoding($response,"UTF-8", "SJIS"));
        if( strpos($arrResponse[0],"C-CHECK:OK") !== false ){
            LC_Helper_Mdl_Dchk::log('update order status: ORDER_NEW');
            $objQuery->update('dtb_order',$sqlval, 'order_id = ?', array($order_id));
        }else{
            LC_Helper_Mdl_Dchk::log('クレジットカード決済の確定に失敗しました。');
        }
        unset($_SESSION["use_regcard"]);
    }

    //決済金額が0円の時は決済をスキップ
    function skipSettlement($order_id,$mobile) {
        LC_Helper_Mdl_Dchk::log('決済金額が0円のため決済処理をスキップします。');
        $sqlval = array(
            'update_date' => 'now()',
            'dchk_status' => DCHK_STATUS_WAIT,
            'status'=> ORDER_NEW
        );
        $objQuery = new SC_Query();
        $objQuery->update('dtb_order',$sqlval, 'order_id = ?', array($order_id));

        $objSiteSess = new SC_SiteSession();
        $objSiteSess->setRegistFlag();
        LC_Helper_Mdl_Dchk::log('完了ページに移動します');
        $this->sendRedirect($this->getLocation(URL_SHOP_COMPLETE),$mobile);
   }
}
?>
