<?php
require_once (CLASS_PATH . 'pages/LC_Page.php');
require_once (MODULE_PATH . "mdl_dchk/class/helper/LC_Helper_Mdl_Dchk.php");

class LC_Page_Mdl_Dchk_Interface extends LC_Page {

    var $arrRes = array(
    );
    var $arrCvs = array("VISA","MASTER","JCB","AMEX","DINERS","CREDIT");
    
    /**
     * Page を初期化する.
     *
     * @return void
     */
    function init() {
        parent::init();
        $arrConfig = LC_Helper_Mdl_Dchk::getConfig();
        foreach($arrConfig as $key=>$val){
            $this->$key = $val;
        }
        LC_Helper_Mdl_Dchk::log('決済通知受け取り開始');
    }


    /**
     * Page のプロセス.
     *
     * @return void
     */
    function process() {
        parent::process();
        $this->action();
    }

    /**
     * デストラクタ.
     *
     * @return void
     */
    function destroy() {
        parent::destroy();
    }

    /**
     * Page のアクション.
     *
     * @return void
     */
    function action() {
        $this->initParam();
        if($this->arrRes["SID"] > 0){
            $this->updateOrder();
            header("Content-type: text/plain");
            echo $this->rtcode;
            exit;
        }else{
            exit;
        }
        
    }
    
    function updateOrder(){
        $objQuery = new SC_Query();
        $ret = $objQuery->SELECT("memo09,memo10","dtb_order","order_id = ?",array($this->arrRes["SID"]));
        $count = $ret[0]["memo09"];
        $lastSeq = $ret[0]["memo10"];
        if($lastSeq != $this->arrRes["SEQ"]){ //最後に受取ったSEQと異なる場合
            if($this->status == DCHK_STATUS_CANCEL){
                $count--;
                if($count <= 0 && $this->rtcode == '0'){
                    $this->order_status = ORDER_CANCEL;
                }
            }else{
                $count++;
            }
        }
        $sqlval = array(
            "dchk_status"=>$this->status,
            "status"=>$this->order_status,
            "memo10"=>$this->arrRes["SEQ"],
            "memo09"=>$count
        );
        $objQuery->update("dtb_order",$sqlval,"order_id = ?" , array($this->arrRes["SID"]));
        LC_Helper_Mdl_Dchk::log('決済通知データで受注情報を更新 : ',$sqlval);
    }
    
    function initParam(){
        if(count($_REQUEST) == 0){
            LC_Helper_Mdl_Dchk::log('受信データ無し。終了');
            exit;
        }
        foreach($_REQUEST as $key=>$val){
            $this->arrRes[$key] = $val;
            $i++;
        }
        $this->rtcode = '0';
        $objQuery = new SC_Query();
        $ret = $objQuery->SELECT("status","dtb_order","order_id = ?",array($this->arrRes["SID"]));
        $bgStatus = $ret[0]["status"];
        if(isset($_REQUEST["TIME"])){//完了通知
            if(in_array($_REQUEST["CVS"],$this->arrCvs)){ //クレジット決済
                LC_Helper_Mdl_Dchk::log('通知種別 : 与信通知（CR）',$this->arrRes);
                if($bgStatus == ORDER_PENDING){
                    $this->order_status = ORDER_PAY_WAIT;
                }else{
                    $this->order_status = $bgStatus;
                    $this->rtcode = '9';
                }
                $this->status = DCHK_STATUS_WAIT;
            }else{ //コンビニ決済
                LC_Helper_Mdl_Dchk::log('通知種別 : 入金通知（CVS）',$this->arrRes);
                if($bgStatus == ORDER_PAY_WAIT){
                    $this->order_status = ORDER_PRE_END;
                }else{
                    $this->order_status = $bgStatus;
                    $this->rtcode = '9';
                }
                $this->status = DCHK_STATUS_COMPLETE;
            }
        }else{//キャンセル通知
            LC_Helper_Mdl_Dchk::log('通知種別 : キャンセル',$this->arrRes);
            if($bgStatus == ORDER_PRE_END){
                $this->order_status = $bgStatus;
            }else{
                $this->order_status = $bgStatus;
                $this->rtcode = '9';
            }
            $this->status = DCHK_STATUS_CANCEL;
        }
    }
    function doValidToken() {
        // nothing.
    }
}
?>
